#include "stdafx.h"
#include "CppUnitTest.h"
#include "specializations.h"
#include <BWAPI.h>
#include "unitTypeHelpers.h"
#include "helpers.h"

using namespace Microsoft::VisualStudio::CppUnitTestFramework;

// TODO
// upgrades
// abilities
// requiredUnits
// whatBuilds
// enum verify

namespace BWAPILIBTest
{
  TEST_CLASS(UnitTypesTest)
  {
  public:
    TEST_METHOD(TestTerran_Marine)
    {
      auto t = BWAPI::UnitTypes::Terran_Marine;
      
      Assert_enum(Terran_Marine);

      AssertSetEquals({ BWAPI::UpgradeTypes::Terran_Infantry_Armor, BWAPI::UpgradeTypes::Terran_Infantry_Weapons, BWAPI::UpgradeTypes::U_238_Shells }, t.upgrades());
      
      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(360);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(100);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(9);
      Assert_dimensionRight(8);
      Assert_dimensionDown(10);
      Assert_width(17);
      Assert_height(20);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(Gauss_Rifle);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Gauss_Rifle);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Ghost)
    {
      auto t = BWAPI::UnitTypes::Terran_Ghost;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(45);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(0);
      Assert_mineralPrice(25);
      Assert_gasPrice(75);
      Assert_buildTime(750);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(175);
      Assert_destroyScore(350);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(C_10_Canister_Rifle);
      Assert_maxGroundHits(1);
      Assert_airWeapon(C_10_Canister_Rifle);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Vulture)
    {
      auto t = BWAPI::UnitTypes::Terran_Vulture;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(80);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(75);
      Assert_gasPrice(0);
      Assert_buildTime(450);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(150);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Fragmentation_Grenade);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(6.40000);
      Assert_acceleration(100);
      Assert_haltDistance(14569);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Goliath)
    {
      auto t = BWAPI::UnitTypes::Terran_Goliath;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(125);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(400);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(160);
      Assert_sightRange(256);
      Assert_groundWeapon(Twin_Autocannons);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Hellfire_Missile_Pack);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.57000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(17);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Siege_Tank_Tank_Mode)
    {
      auto t = BWAPI::UnitTypes::Terran_Siege_Tank_Tank_Mode;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(150);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(350);
      Assert_destroyScore(700);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(Arclite_Cannon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(13);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_SCV)
    {
      auto t = BWAPI::UnitTypes::Terran_SCV;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(100);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(11);
      Assert_dimensionRight(11);
      Assert_dimensionDown(11);
      Assert_width(23);
      Assert_height(23);
      Assert_seekRange(32);
      Assert_sightRange(224);
      Assert_groundWeapon(Fusion_Cutter);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(67);
      Assert_haltDistance(12227);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(true);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Wraith)
    {
      auto t = BWAPI::UnitTypes::Terran_Wraith;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Cloaking_Field);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(120);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(0);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(900);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(800);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(19);
      Assert_dimensionUp(15);
      Assert_dimensionRight(18);
      Assert_dimensionDown(14);
      Assert_width(38);
      Assert_height(30);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(Burst_Lasers);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Gemini_Missiles);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Science_Vessel)
    {
      auto t = BWAPI::UnitTypes::Terran_Science_Vessel;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(225);
      Assert_buildTime(1200);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(625);
      Assert_destroyScore(1250);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(33);
      Assert_dimensionRight(32);
      Assert_dimensionDown(16);
      Assert_width(65);
      Assert_height(50);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.00000);
      Assert_acceleration(50);
      Assert_haltDistance(5120);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Gui_Montag)
    {
      auto t = BWAPI::UnitTypes::Hero_Gui_Montag;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(160);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(100);
      Assert_gasPrice(50);
      Assert_buildTime(720);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(7);
      Assert_dimensionRight(11);
      Assert_dimensionDown(14);
      Assert_width(23);
      Assert_height(22);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Flame_Thrower_Gui_Montag);
      Assert_maxGroundHits(3);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Dropship)
    {
      auto t = BWAPI::UnitTypes::Terran_Dropship;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(150);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(8);
      Assert_buildScore(300);
      Assert_destroyScore(600);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(16);
      Assert_dimensionRight(24);
      Assert_dimensionDown(20);
      Assert_width(49);
      Assert_height(37);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.47000);
      Assert_acceleration(17);
      Assert_haltDistance(37756);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Battlecruiser)
    {
      auto t = BWAPI::UnitTypes::Terran_Battlecruiser;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(500);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(3);
      Assert_mineralPrice(400);
      Assert_gasPrice(300);
      Assert_buildTime(2000);
      Assert_supplyRequired(12);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(1200);
      Assert_destroyScore(2400);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(29);
      Assert_dimensionRight(37);
      Assert_dimensionDown(29);
      Assert_width(75);
      Assert_height(59);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(ATS_Laser_Battery);
      Assert_maxGroundHits(1);
      Assert_airWeapon(ATA_Laser_Battery);
      Assert_maxAirHits(1);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Vulture_Spider_Mine)
    {
      auto t = BWAPI::UnitTypes::Terran_Vulture_Spider_Mine;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(20);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(25);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(7);
      Assert_dimensionRight(7);
      Assert_dimensionDown(7);
      Assert_width(15);
      Assert_height(15);
      Assert_seekRange(96);
      Assert_sightRange(96);
      Assert_groundWeapon(Spider_Mines);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(16.0000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(127);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Nuclear_Missile)
    {
      auto t = BWAPI::UnitTypes::Terran_Nuclear_Missile;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(200);
      Assert_gasPrice(200);
      Assert_buildTime(1500);
      Assert_supplyRequired(16);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(800);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(14);
      Assert_dimensionRight(7);
      Assert_dimensionDown(14);
      Assert_width(15);
      Assert_height(29);
      Assert_seekRange(0);
      Assert_sightRange(96);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(33.3300);
      Assert_acceleration(33);
      Assert_haltDistance(1103213);
      Assert_turnRadius(127);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Civilian)
    {
      auto t = BWAPI::UnitTypes::Terran_Civilian;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(9);
      Assert_dimensionRight(8);
      Assert_dimensionDown(10);
      Assert_width(17);
      Assert_height(20);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Sarah_Kerrigan)
    {
      auto t = BWAPI::UnitTypes::Hero_Sarah_Kerrigan;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(50);
      Assert_gasPrice(150);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(700);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(C_10_Canister_Rifle_Sarah_Kerrigan);
      Assert_maxGroundHits(1);
      Assert_airWeapon(C_10_Canister_Rifle_Sarah_Kerrigan);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Alan_Schezar)
    {
      auto t = BWAPI::UnitTypes::Hero_Alan_Schezar;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(200);
      Assert_gasPrice(100);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(800);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(160);
      Assert_sightRange(256);
      Assert_groundWeapon(Twin_Autocannons_Alan_Schezar);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Hellfire_Missile_Pack_Alan_Schezar);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.57000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(17);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Jim_Raynor_Vulture)
    {
      auto t = BWAPI::UnitTypes::Hero_Jim_Raynor_Vulture;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(300);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Fragmentation_Grenade_Jim_Raynor);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(6.40000);
      Assert_acceleration(100);
      Assert_haltDistance(14569);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Jim_Raynor_Marine)
    {
      auto t = BWAPI::UnitTypes::Hero_Jim_Raynor_Marine;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(200);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(9);
      Assert_dimensionRight(8);
      Assert_dimensionDown(10);
      Assert_width(17);
      Assert_height(20);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(Gauss_Rifle_Jim_Raynor);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Gauss_Rifle_Jim_Raynor);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Tom_Kazansky)
    {
      auto t = BWAPI::UnitTypes::Hero_Tom_Kazansky;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Cloaking_Field);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(500);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(400);
      Assert_gasPrice(200);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1600);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(19);
      Assert_dimensionUp(15);
      Assert_dimensionRight(18);
      Assert_dimensionDown(14);
      Assert_width(38);
      Assert_height(30);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(Burst_Lasers_Tom_Kazansky);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Gemini_Missiles_Tom_Kazansky);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Magellan)
    {
      auto t = BWAPI::UnitTypes::Hero_Magellan;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(50);
      Assert_gasPrice(600);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2500);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(33);
      Assert_dimensionRight(32);
      Assert_dimensionDown(16);
      Assert_width(65);
      Assert_height(50);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.00000);
      Assert_acceleration(50);
      Assert_haltDistance(5120);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Edmund_Duke_Tank_Mode)
    {
      auto t = BWAPI::UnitTypes::Hero_Edmund_Duke_Tank_Mode;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(300);
      Assert_gasPrice(200);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1400);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(Arclite_Cannon_Edmund_Duke);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(13);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Edmund_Duke_Siege_Mode)
    {
      auto t = BWAPI::UnitTypes::Hero_Edmund_Duke_Siege_Mode;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(300);
      Assert_gasPrice(200);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1400);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(Arclite_Shock_Cannon_Edmund_Duke);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Arcturus_Mengsk)
    {
      auto t = BWAPI::UnitTypes::Hero_Arcturus_Mengsk;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(1000);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(800);
      Assert_gasPrice(600);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(29);
      Assert_dimensionRight(37);
      Assert_dimensionDown(29);
      Assert_width(75);
      Assert_height(59);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(ATS_Laser_Battery_Hero);
      Assert_maxGroundHits(1);
      Assert_airWeapon(ATA_Laser_Battery_Hero);
      Assert_maxAirHits(1);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Hyperion)
    {
      auto t = BWAPI::UnitTypes::Hero_Hyperion;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(800);
      Assert_gasPrice(600);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(29);
      Assert_dimensionRight(37);
      Assert_dimensionDown(29);
      Assert_width(75);
      Assert_height(59);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(ATS_Laser_Battery_Hyperion);
      Assert_maxGroundHits(1);
      Assert_airWeapon(ATA_Laser_Battery_Hyperion);
      Assert_maxAirHits(1);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Norad_II)
    {
      auto t = BWAPI::UnitTypes::Hero_Norad_II;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(700);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(800);
      Assert_gasPrice(600);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(29);
      Assert_dimensionRight(37);
      Assert_dimensionDown(29);
      Assert_width(75);
      Assert_height(59);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(ATS_Laser_Battery_Hero);
      Assert_maxGroundHits(1);
      Assert_airWeapon(ATA_Laser_Battery_Hero);
      Assert_maxAirHits(1);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Siege_Tank_Siege_Mode)
    {
      auto t = BWAPI::UnitTypes::Terran_Siege_Tank_Siege_Mode;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Vehicle_Plating);
      Assert_maxHitPoints(150);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(700);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(Arclite_Shock_Cannon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Firebat)
    {
      auto t = BWAPI::UnitTypes::Terran_Firebat;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(25);
      Assert_buildTime(360);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(200);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(7);
      Assert_dimensionRight(11);
      Assert_dimensionDown(14);
      Assert_width(23);
      Assert_height(22);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Flame_Thrower);
      Assert_maxGroundHits(3);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpell_Scanner_Sweep)
    {
      auto t = BWAPI::UnitTypes::Spell_Scanner_Sweep;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(0);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(13);
      Assert_dimensionUp(13);
      Assert_dimensionRight(13);
      Assert_dimensionDown(17);
      Assert_width(27);
      Assert_height(31);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(true);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Medic)
    {
      auto t = BWAPI::UnitTypes::Terran_Medic;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(25);
      Assert_buildTime(450);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(125);
      Assert_destroyScore(250);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(9);
      Assert_dimensionRight(8);
      Assert_dimensionDown(10);
      Assert_width(17);
      Assert_height(20);
      Assert_seekRange(288);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Larva)
    {
      auto t = BWAPI::UnitTypes::Zerg_Larva;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(25);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(10);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(8);
      Assert_dimensionRight(7);
      Assert_dimensionDown(7);
      Assert_width(16);
      Assert_height(16);
      Assert_seekRange(0);
      Assert_sightRange(128);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Egg)
    {
      auto t = BWAPI::UnitTypes::Zerg_Egg;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(10);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(25);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(128);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Zergling)
    {
      auto t = BWAPI::UnitTypes::Zerg_Zergling;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(35);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(420);
      Assert_supplyRequired(1);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(25);
      Assert_destroyScore(50);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(4);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(16);
      Assert_height(16);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(Claws);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.49000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(true);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Hydralisk)
    {
      auto t = BWAPI::UnitTypes::Zerg_Hydralisk;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(80);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(75);
      Assert_gasPrice(25);
      Assert_buildTime(420);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(125);
      Assert_destroyScore(350);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(10);
      Assert_dimensionUp(10);
      Assert_dimensionRight(10);
      Assert_dimensionDown(12);
      Assert_width(21);
      Assert_height(23);
      Assert_seekRange(0);
      Assert_sightRange(192);
      Assert_groundWeapon(Needle_Spines);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Needle_Spines);
      Assert_maxAirHits(1);
      Assert_topSpeed(3.66000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Ultralisk)
    {
      auto t = BWAPI::UnitTypes::Zerg_Ultralisk;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(200);
      Assert_buildTime(900);
      Assert_supplyRequired(8);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(650);
      Assert_destroyScore(1300);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(19);
      Assert_dimensionUp(16);
      Assert_dimensionRight(18);
      Assert_dimensionDown(15);
      Assert_width(38);
      Assert_height(32);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Kaiser_Blades);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.12000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Broodling)
    {
      auto t = BWAPI::UnitTypes::Zerg_Broodling;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(30);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(25);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(9);
      Assert_dimensionUp(9);
      Assert_dimensionRight(9);
      Assert_dimensionDown(9);
      Assert_width(19);
      Assert_height(19);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(Toxic_Spores);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(6.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Drone)
    {
      auto t = BWAPI::UnitTypes::Zerg_Drone;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(40);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(100);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(11);
      Assert_dimensionRight(11);
      Assert_dimensionDown(11);
      Assert_width(23);
      Assert_height(23);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(Spines);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(67);
      Assert_haltDistance(12227);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(true);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Overlord)
    {
      auto t = BWAPI::UnitTypes::Zerg_Overlord;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(16);
      Assert_spaceRequired(255);
      Assert_spaceProvided(8);
      Assert_buildScore(100);
      Assert_destroyScore(200);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(25);
      Assert_dimensionUp(25);
      Assert_dimensionRight(24);
      Assert_dimensionDown(24);
      Assert_width(50);
      Assert_height(50);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.830000);
      Assert_acceleration(27);
      Assert_haltDistance(840);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Mutalisk)
    {
      auto t = BWAPI::UnitTypes::Zerg_Mutalisk;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(120);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(300);
      Assert_destroyScore(600);
      Assert_size(Small);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Glave_Wurm);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Glave_Wurm);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Guardian)
    {
      auto t = BWAPI::UnitTypes::Zerg_Guardian;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(150);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(50);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(550);
      Assert_destroyScore(1100);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(Acid_Spore);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Queen)
    {
      auto t = BWAPI::UnitTypes::Zerg_Queen;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(120);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(800);
      Assert_size(Medium);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(23);
      Assert_dimensionDown(23);
      Assert_width(48);
      Assert_height(48);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Defiler)
    {
      auto t = BWAPI::UnitTypes::Zerg_Defiler;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(80);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(150);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(225);
      Assert_destroyScore(450);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(13);
      Assert_dimensionUp(12);
      Assert_dimensionRight(13);
      Assert_dimensionDown(12);
      Assert_width(27);
      Assert_height(25);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Scourge)
    {
      auto t = BWAPI::UnitTypes::Zerg_Scourge;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(25);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(25);
      Assert_gasPrice(75);
      Assert_buildTime(450);
      Assert_supplyRequired(1);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(200);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(12);
      Assert_dimensionRight(11);
      Assert_dimensionDown(11);
      Assert_width(24);
      Assert_height(24);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Suicide_Scourge);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(107);
      Assert_haltDistance(13616);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(true);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Torrasque)
    {
      auto t = BWAPI::UnitTypes::Hero_Torrasque;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(4);
      Assert_mineralPrice(400);
      Assert_gasPrice(400);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2600);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(19);
      Assert_dimensionUp(16);
      Assert_dimensionRight(18);
      Assert_dimensionDown(15);
      Assert_width(38);
      Assert_height(32);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Kaiser_Blades_Torrasque);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.12000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Matriarch)
    {
      auto t = BWAPI::UnitTypes::Hero_Matriarch;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(200);
      Assert_gasPrice(300);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1600);
      Assert_size(Medium);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(23);
      Assert_dimensionDown(23);
      Assert_width(48);
      Assert_height(48);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Infested_Terran)
    {
      auto t = BWAPI::UnitTypes::Zerg_Infested_Terran;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(9);
      Assert_dimensionRight(8);
      Assert_dimensionDown(10);
      Assert_width(17);
      Assert_height(20);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(Suicide_Infested_Terran);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.82000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Infested_Kerrigan)
    {
      auto t = BWAPI::UnitTypes::Hero_Infested_Kerrigan;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(2);
      Assert_mineralPrice(200);
      Assert_gasPrice(300);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4000);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(96);
      Assert_sightRange(288);
      Assert_groundWeapon(Claws_Infested_Kerrigan);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Unclean_One)
    {
      auto t = BWAPI::UnitTypes::Hero_Unclean_One;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(50);
      Assert_gasPrice(200);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(900);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(13);
      Assert_dimensionUp(12);
      Assert_dimensionRight(13);
      Assert_dimensionDown(12);
      Assert_width(27);
      Assert_height(25);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Hunter_Killer)
    {
      auto t = BWAPI::UnitTypes::Hero_Hunter_Killer;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(160);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(150);
      Assert_gasPrice(50);
      Assert_buildTime(780);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(500);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(10);
      Assert_dimensionUp(10);
      Assert_dimensionRight(10);
      Assert_dimensionDown(12);
      Assert_width(21);
      Assert_height(23);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Needle_Spines_Hunter_Killer);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Needle_Spines_Hunter_Killer);
      Assert_maxAirHits(1);
      Assert_topSpeed(3.66000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Devouring_One)
    {
      auto t = BWAPI::UnitTypes::Hero_Devouring_One;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(120);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(840);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(4);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(16);
      Assert_height(16);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(Claws_Devouring_One);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.49000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(true);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Kukulza_Mutalisk)
    {
      auto t = BWAPI::UnitTypes::Hero_Kukulza_Mutalisk;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(200);
      Assert_gasPrice(200);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1200);
      Assert_size(Small);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Glave_Wurm_Kukulza);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Glave_Wurm_Kukulza);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(21745);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Kukulza_Guardian)
    {
      auto t = BWAPI::UnitTypes::Hero_Kukulza_Guardian;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(4);
      Assert_mineralPrice(100);
      Assert_gasPrice(200);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2200);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(Acid_Spore_Kukulza);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Yggdrasill)
    {
      auto t = BWAPI::UnitTypes::Hero_Yggdrasill;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(1000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(4);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(60);
      Assert_spaceRequired(255);
      Assert_spaceProvided(8);
      Assert_buildScore(0);
      Assert_destroyScore(400);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(25);
      Assert_dimensionUp(25);
      Assert_dimensionRight(24);
      Assert_dimensionDown(24);
      Assert_width(50);
      Assert_height(50);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.830000);
      Assert_acceleration(27);
      Assert_haltDistance(840);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Valkyrie)
    {
      auto t = BWAPI::UnitTypes::Terran_Valkyrie;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(250);
      Assert_gasPrice(125);
      Assert_buildTime(750);
      Assert_supplyRequired(6);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(16);
      Assert_dimensionRight(24);
      Assert_dimensionDown(20);
      Assert_width(49);
      Assert_height(37);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Halo_Rockets);
      Assert_maxAirHits(4);
      Assert_topSpeed(6.60000);
      Assert_acceleration(65);
      Assert_haltDistance(21901);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Cocoon)
    {
      auto t = BWAPI::UnitTypes::Zerg_Cocoon;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1100);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(128);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Corsair)
    {
      auto t = BWAPI::UnitTypes::Protoss_Corsair;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(80);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(350);
      Assert_destroyScore(700);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(18);
      Assert_dimensionUp(16);
      Assert_dimensionRight(17);
      Assert_dimensionDown(15);
      Assert_width(36);
      Assert_height(32);
      Assert_seekRange(288);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Neutron_Flare);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Dark_Templar)
    {
      auto t = BWAPI::UnitTypes::Protoss_Dark_Templar;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(80);
      Assert_maxShields(40);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(125);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(325);
      Assert_destroyScore(650);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(6);
      Assert_dimensionRight(11);
      Assert_dimensionDown(19);
      Assert_width(24);
      Assert_height(26);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Warp_Blades);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(true);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Devourer)
    {
      auto t = BWAPI::UnitTypes::Zerg_Devourer;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Flyer_Carapace);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(150);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(550);
      Assert_destroyScore(1100);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(224);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Corrosive_Acid);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(48);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Dark_Archon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Dark_Archon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(25);
      Assert_maxShields(200);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(8);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(650);
      Assert_destroyScore(1300);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(224);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(160);
      Assert_haltDistance(5120);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Probe)
    {
      auto t = BWAPI::UnitTypes::Protoss_Probe;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(20);
      Assert_maxShields(20);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(100);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(11);
      Assert_dimensionRight(11);
      Assert_dimensionDown(11);
      Assert_width(23);
      Assert_height(23);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Particle_Beam);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(67);
      Assert_haltDistance(12227);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(true);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(true);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Zealot)
    {
      auto t = BWAPI::UnitTypes::Protoss_Zealot;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(60);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(200);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(5);
      Assert_dimensionRight(11);
      Assert_dimensionDown(13);
      Assert_width(23);
      Assert_height(19);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Psi_Blades);
      Assert_maxGroundHits(2);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Dragoon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Dragoon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(80);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(125);
      Assert_gasPrice(50);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(250);
      Assert_destroyScore(500);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(15);
      Assert_dimensionUp(15);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Phase_Disruptor);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Phase_Disruptor);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_High_Templar)
    {
      auto t = BWAPI::UnitTypes::Protoss_High_Templar;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(40);
      Assert_maxEnergy(200);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(150);
      Assert_buildTime(750);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(350);
      Assert_destroyScore(700);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(10);
      Assert_dimensionRight(11);
      Assert_dimensionDown(13);
      Assert_width(24);
      Assert_height(24);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.20000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Archon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Archon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(10);
      Assert_maxShields(350);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(8);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(700);
      Assert_destroyScore(1400);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(96);
      Assert_sightRange(256);
      Assert_groundWeapon(Psionic_Shockwave);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Psionic_Shockwave);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.92000);
      Assert_acceleration(160);
      Assert_haltDistance(5120);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Shuttle)
    {
      auto t = BWAPI::UnitTypes::Protoss_Shuttle;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(80);
      Assert_maxShields(60);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(8);
      Assert_buildScore(200);
      Assert_destroyScore(400);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(20);
      Assert_dimensionUp(16);
      Assert_dimensionRight(19);
      Assert_dimensionDown(15);
      Assert_width(40);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.43000);
      Assert_acceleration(17);
      Assert_haltDistance(37756);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(true);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Scout)
    {
      auto t = BWAPI::UnitTypes::Protoss_Scout;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(150);
      Assert_maxShields(100);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(275);
      Assert_gasPrice(125);
      Assert_buildTime(1200);
      Assert_supplyRequired(6);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(650);
      Assert_destroyScore(1300);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(18);
      Assert_dimensionUp(16);
      Assert_dimensionRight(17);
      Assert_dimensionDown(15);
      Assert_width(36);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Dual_Photon_Blasters);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Anti_Matter_Missiles);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(48);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Arbiter)
    {
      auto t = BWAPI::UnitTypes::Protoss_Arbiter;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(200);
      Assert_maxShields(150);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(350);
      Assert_buildTime(2400);
      Assert_supplyRequired(8);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(1025);
      Assert_destroyScore(2050);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(Phase_Disruptor_Cannon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Phase_Disruptor_Cannon);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(33);
      Assert_haltDistance(24824);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Carrier)
    {
      auto t = BWAPI::UnitTypes::Protoss_Carrier;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(300);
      Assert_maxShields(150);
      Assert_maxEnergy(0);
      Assert_armor(4);
      Assert_mineralPrice(350);
      Assert_gasPrice(250);
      Assert_buildTime(2100);
      Assert_supplyRequired(12);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(950);
      Assert_destroyScore(1900);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(256);
      Assert_sightRange(352);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.33000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(20);
      Assert_canProduce(true);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Interceptor)
    {
      auto t = BWAPI::UnitTypes::Protoss_Interceptor;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(40);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(25);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(30);
      Assert_destroyScore(60);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(8);
      Assert_dimensionUp(8);
      Assert_dimensionRight(7);
      Assert_dimensionDown(7);
      Assert_width(16);
      Assert_height(16);
      Assert_seekRange(0);
      Assert_sightRange(192);
      Assert_groundWeapon(Pulse_Cannon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Pulse_Cannon);
      Assert_maxAirHits(1);
      Assert_topSpeed(13.3300);
      Assert_acceleration(427);
      Assert_haltDistance(13640);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Dark_Templar)
    {
      auto t = BWAPI::UnitTypes::Hero_Dark_Templar;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(80);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(150);
      Assert_gasPrice(150);
      Assert_buildTime(750);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(6);
      Assert_dimensionRight(11);
      Assert_dimensionDown(19);
      Assert_width(24);
      Assert_height(26);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Warp_Blades_Hero);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(true);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Zeratul)
    {
      auto t = BWAPI::UnitTypes::Hero_Zeratul;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(60);
      Assert_maxShields(400);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(300);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(800);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(6);
      Assert_dimensionRight(11);
      Assert_dimensionDown(19);
      Assert_width(24);
      Assert_height(26);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Warp_Blades_Zeratul);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.92000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(true);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Tassadar_Zeratul_Archon)
    {
      auto t = BWAPI::UnitTypes::Hero_Tassadar_Zeratul_Archon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(800);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2800);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(96);
      Assert_sightRange(256);
      Assert_groundWeapon(Psionic_Shockwave_TZ_Archon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Psionic_Shockwave_TZ_Archon);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.92000);
      Assert_acceleration(160);
      Assert_haltDistance(5120);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Fenix_Zealot)
    {
      auto t = BWAPI::UnitTypes::Hero_Fenix_Zealot;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(240);
      Assert_maxShields(240);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(11);
      Assert_dimensionUp(5);
      Assert_dimensionRight(11);
      Assert_dimensionDown(13);
      Assert_width(23);
      Assert_height(19);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Psi_Blades_Fenix);
      Assert_maxGroundHits(2);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Fenix_Dragoon)
    {
      auto t = BWAPI::UnitTypes::Hero_Fenix_Dragoon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(240);
      Assert_maxShields(240);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(300);
      Assert_gasPrice(100);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1000);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(15);
      Assert_dimensionUp(15);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(Phase_Disruptor_Fenix);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Phase_Disruptor_Fenix);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Tassadar)
    {
      auto t = BWAPI::UnitTypes::Hero_Tassadar;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(80);
      Assert_maxShields(300);
      Assert_maxEnergy(250);
      Assert_armor(2);
      Assert_mineralPrice(100);
      Assert_gasPrice(300);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(10);
      Assert_dimensionRight(11);
      Assert_dimensionDown(13);
      Assert_width(24);
      Assert_height(24);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Psi_Assault);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.20000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Mojo)
    {
      auto t = BWAPI::UnitTypes::Hero_Mojo;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(400);
      Assert_maxShields(400);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(600);
      Assert_gasPrice(300);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2600);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(18);
      Assert_dimensionUp(16);
      Assert_dimensionRight(17);
      Assert_dimensionDown(15);
      Assert_width(36);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(Dual_Photon_Blasters_Mojo);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Anti_Matter_Missiles_Mojo);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(48);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Warbringer)
    {
      auto t = BWAPI::UnitTypes::Hero_Warbringer;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(200);
      Assert_maxShields(400);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(400);
      Assert_gasPrice(200);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1600);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.78000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(20);
      Assert_canProduce(true);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(true);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Gantrithor)
    {
      auto t = BWAPI::UnitTypes::Hero_Gantrithor;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(800);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(4);
      Assert_mineralPrice(700);
      Assert_gasPrice(600);
      Assert_buildTime(4200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(3800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(256);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.33000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(20);
      Assert_canProduce(true);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Reaver)
    {
      auto t = BWAPI::UnitTypes::Protoss_Reaver;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(80);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(200);
      Assert_gasPrice(100);
      Assert_buildTime(1050);
      Assert_supplyRequired(8);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(800);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(256);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.78000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(20);
      Assert_canProduce(true);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(true);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Observer)
    {
      auto t = BWAPI::UnitTypes::Protoss_Observer;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(40);
      Assert_maxShields(20);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(25);
      Assert_gasPrice(75);
      Assert_buildTime(600);
      Assert_supplyRequired(2);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(225);
      Assert_destroyScore(450);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.33000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(true);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(true);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Scarab)
    {
      auto t = BWAPI::UnitTypes::Protoss_Scarab;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(20);
      Assert_maxShields(10);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(15);
      Assert_gasPrice(0);
      Assert_buildTime(105);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(2);
      Assert_dimensionUp(2);
      Assert_dimensionRight(2);
      Assert_dimensionDown(2);
      Assert_width(5);
      Assert_height(5);
      Assert_seekRange(96);
      Assert_sightRange(160);
      Assert_groundWeapon(Scarab);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(16.0000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Danimoth)
    {
      auto t = BWAPI::UnitTypes::Hero_Danimoth;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(600);
      Assert_maxShields(500);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(50);
      Assert_gasPrice(1000);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4100);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(22);
      Assert_dimensionUp(22);
      Assert_dimensionRight(21);
      Assert_dimensionDown(21);
      Assert_width(44);
      Assert_height(44);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(Phase_Disruptor_Cannon_Danimoth);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Phase_Disruptor_Cannon_Danimoth);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(33);
      Assert_haltDistance(24824);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Aldaris)
    {
      auto t = BWAPI::UnitTypes::Hero_Aldaris;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Ground_Armor);
      Assert_maxHitPoints(80);
      Assert_maxShields(300);
      Assert_maxEnergy(250);
      Assert_armor(2);
      Assert_mineralPrice(100);
      Assert_gasPrice(300);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(2);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1400);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(12);
      Assert_dimensionUp(10);
      Assert_dimensionRight(11);
      Assert_dimensionDown(13);
      Assert_width(24);
      Assert_height(24);
      Assert_seekRange(96);
      Assert_sightRange(224);
      Assert_groundWeapon(Psi_Assault);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(3.20000);
      Assert_acceleration(27);
      Assert_haltDistance(13474);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Artanis)
    {
      auto t = BWAPI::UnitTypes::Hero_Artanis;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(250);
      Assert_maxShields(250);
      Assert_maxEnergy(0);
      Assert_armor(3);
      Assert_mineralPrice(600);
      Assert_gasPrice(300);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2400);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(18);
      Assert_dimensionUp(16);
      Assert_dimensionRight(17);
      Assert_dimensionDown(15);
      Assert_width(36);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(Dual_Photon_Blasters_Artanis);
      Assert_maxGroundHits(1);
      Assert_airWeapon(Anti_Matter_Missiles_Artanis);
      Assert_maxAirHits(1);
      Assert_topSpeed(5.00000);
      Assert_acceleration(48);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Rhynadon)
    {
      auto t = BWAPI::UnitTypes::Critter_Rhynadon;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Bengalaas)
    {
      auto t = BWAPI::UnitTypes::Critter_Bengalaas;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Cargo_Ship)
    {
      auto t = BWAPI::UnitTypes::Special_Cargo_Ship;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(125);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(15);
      Assert_dimensionUp(15);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(256);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Mercenary_Gunship)
    {
      auto t = BWAPI::UnitTypes::Special_Mercenary_Gunship;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(125);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(15);
      Assert_dimensionUp(15);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(128);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Scantid)
    {
      auto t = BWAPI::UnitTypes::Critter_Scantid;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Kakaru)
    {
      auto t = BWAPI::UnitTypes::Critter_Kakaru;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.00000);
      Assert_acceleration(16);
      Assert_haltDistance(51200);
      Assert_turnRadius(14);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Ragnasaur)
    {
      auto t = BWAPI::UnitTypes::Critter_Ragnasaur;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestCritter_Ursadon)
    {
      auto t = BWAPI::UnitTypes::Critter_Ursadon;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(60);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(true);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Lurker_Egg)
    {
      auto t = BWAPI::UnitTypes::Zerg_Lurker_Egg;

      Assert_getRace(Zerg);
      Assert_requiredTech(Lurker_Aspect);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(10);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(500);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(128);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Raszagal)
    {
      auto t = BWAPI::UnitTypes::Hero_Raszagal;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Protoss_Air_Armor);
      Assert_maxHitPoints(100);
      Assert_maxShields(60);
      Assert_maxEnergy(250);
      Assert_armor(0);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(750);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(1300);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(18);
      Assert_dimensionUp(16);
      Assert_dimensionRight(17);
      Assert_dimensionDown(15);
      Assert_width(36);
      Assert_height(32);
      Assert_seekRange(288);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Neutron_Flare);
      Assert_maxAirHits(1);
      Assert_topSpeed(6.67000);
      Assert_acceleration(67);
      Assert_haltDistance(17067);
      Assert_turnRadius(30);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Samir_Duran)
    {
      auto t = BWAPI::UnitTypes::Hero_Samir_Duran;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(2);
      Assert_mineralPrice(200);
      Assert_gasPrice(75);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(700);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(C_10_Canister_Rifle_Samir_Duran);
      Assert_maxGroundHits(1);
      Assert_airWeapon(C_10_Canister_Rifle_Samir_Duran);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Alexei_Stukov)
    {
      auto t = BWAPI::UnitTypes::Hero_Alexei_Stukov;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Terran_Infantry_Armor);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(200);
      Assert_gasPrice(75);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(700);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(C_10_Canister_Rifle_Alexei_Stukov);
      Assert_maxGroundHits(1);
      Assert_airWeapon(C_10_Canister_Rifle_Alexei_Stukov);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Map_Revealer)
    {
      auto t = BWAPI::UnitTypes::Special_Map_Revealer;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(13);
      Assert_dimensionUp(13);
      Assert_dimensionRight(13);
      Assert_dimensionDown(17);
      Assert_width(27);
      Assert_height(31);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Gerard_DuGalle)
    {
      auto t = BWAPI::UnitTypes::Hero_Gerard_DuGalle;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Terran_Ship_Plating);
      Assert_maxHitPoints(700);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(4);
      Assert_mineralPrice(800);
      Assert_gasPrice(600);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4800);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(29);
      Assert_dimensionRight(37);
      Assert_dimensionDown(29);
      Assert_width(75);
      Assert_height(59);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(ATS_Laser_Battery_Hero);
      Assert_maxGroundHits(1);
      Assert_airWeapon(ATA_Laser_Battery_Hero);
      Assert_maxAirHits(1);
      Assert_topSpeed(2.50000);
      Assert_acceleration(27);
      Assert_haltDistance(7585);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(true);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Lurker)
    {
      auto t = BWAPI::UnitTypes::Zerg_Lurker;

      Assert_getRace(Zerg);
      Assert_requiredTech(Lurker_Aspect);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(125);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(100);
      Assert_buildTime(600);
      Assert_supplyRequired(4);
      Assert_supplyProvided(0);
      Assert_spaceRequired(4);
      Assert_spaceProvided(0);
      Assert_buildScore(250);
      Assert_destroyScore(500);
      Assert_size(Medium);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(15);
      Assert_dimensionUp(15);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(192);
      Assert_sightRange(256);
      Assert_groundWeapon(Subterranean_Spines);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(5.82000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(true);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestHero_Infested_Duran)
    {
      auto t = BWAPI::UnitTypes::Hero_Infested_Duran;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(Personnel_Cloaking);
      Assert_armorUpgrade(Zerg_Carapace);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(250);
      Assert_armor(3);
      Assert_mineralPrice(200);
      Assert_gasPrice(75);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(1);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(700);
      Assert_size(Small);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(7);
      Assert_dimensionUp(10);
      Assert_dimensionRight(7);
      Assert_dimensionDown(11);
      Assert_width(15);
      Assert_height(22);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(C_10_Canister_Rifle_Infested_Duran);
      Assert_maxGroundHits(1);
      Assert_airWeapon(C_10_Canister_Rifle_Infested_Duran);
      Assert_maxAirHits(1);
      Assert_topSpeed(4.00000);
      Assert_acceleration(1);
      Assert_haltDistance(1);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(true);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(true);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(true);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpell_Disruption_Web)
    {
      auto t = BWAPI::UnitTypes::Spell_Disruption_Web;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(250);
      Assert_gasPrice(250);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(60);
      Assert_dimensionUp(40);
      Assert_dimensionRight(59);
      Assert_dimensionDown(39);
      Assert_width(120);
      Assert_height(80);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(true);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Command_Center)
    {
      auto t = BWAPI::UnitTypes::Terran_Command_Center;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(400);
      Assert_gasPrice(0);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(20);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(1200);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(58);
      Assert_dimensionUp(41);
      Assert_dimensionRight(58);
      Assert_dimensionDown(41);
      Assert_width(117);
      Assert_height(83);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(true);
    }
    TEST_METHOD(TestTerran_Comsat_Station)
    {
      auto t = BWAPI::UnitTypes::Terran_Comsat_Station;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(0);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(16);
      Assert_dimensionRight(31);
      Assert_dimensionDown(25);
      Assert_width(69);
      Assert_height(42);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Nuclear_Silo)
    {
      auto t = BWAPI::UnitTypes::Terran_Nuclear_Silo;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(37);
      Assert_dimensionUp(16);
      Assert_dimensionRight(31);
      Assert_dimensionDown(25);
      Assert_width(69);
      Assert_height(42);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Supply_Depot)
    {
      auto t = BWAPI::UnitTypes::Terran_Supply_Depot;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(16);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(38);
      Assert_dimensionUp(22);
      Assert_dimensionRight(38);
      Assert_dimensionDown(26);
      Assert_width(77);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Refinery)
    {
      auto t = BWAPI::UnitTypes::Terran_Refinery;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(4, 2));
      Assert_dimensionLeft(56);
      Assert_dimensionUp(32);
      Assert_dimensionRight(56);
      Assert_dimensionDown(31);
      Assert_width(113);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(true);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Barracks)
    {
      auto t = BWAPI::UnitTypes::Terran_Barracks;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(40);
      Assert_dimensionRight(56);
      Assert_dimensionDown(32);
      Assert_width(105);
      Assert_height(73);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Academy)
    {
      auto t = BWAPI::UnitTypes::Terran_Academy;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(44);
      Assert_dimensionDown(24);
      Assert_width(85);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Factory)
    {
      auto t = BWAPI::UnitTypes::Terran_Factory;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1250);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(100);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(600);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(56);
      Assert_dimensionUp(40);
      Assert_dimensionRight(56);
      Assert_dimensionDown(40);
      Assert_width(113);
      Assert_height(81);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(true);
    }
    TEST_METHOD(TestTerran_Starport)
    {
      auto t = BWAPI::UnitTypes::Terran_Starport;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1300);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(1050);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(600);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(40);
      Assert_dimensionRight(48);
      Assert_dimensionDown(38);
      Assert_width(97);
      Assert_height(79);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(true);
    }
    TEST_METHOD(TestTerran_Control_Tower)
    {
      auto t = BWAPI::UnitTypes::Terran_Control_Tower;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(47);
      Assert_dimensionUp(24);
      Assert_dimensionRight(28);
      Assert_dimensionDown(22);
      Assert_width(76);
      Assert_height(47);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Science_Facility)
    {
      auto t = BWAPI::UnitTypes::Terran_Science_Facility;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(150);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(275);
      Assert_destroyScore(825);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(38);
      Assert_dimensionRight(48);
      Assert_dimensionDown(38);
      Assert_width(97);
      Assert_height(77);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(true);
    }
    TEST_METHOD(TestTerran_Covert_Ops)
    {
      auto t = BWAPI::UnitTypes::Terran_Covert_Ops;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(47);
      Assert_dimensionUp(24);
      Assert_dimensionRight(28);
      Assert_dimensionDown(22);
      Assert_width(76);
      Assert_height(47);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Physics_Lab)
    {
      auto t = BWAPI::UnitTypes::Terran_Physics_Lab;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(47);
      Assert_dimensionUp(24);
      Assert_dimensionRight(28);
      Assert_dimensionDown(22);
      Assert_width(76);
      Assert_height(47);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Machine_Shop)
    {
      auto t = BWAPI::UnitTypes::Terran_Machine_Shop;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(39);
      Assert_dimensionUp(24);
      Assert_dimensionRight(31);
      Assert_dimensionDown(24);
      Assert_width(71);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(true);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Engineering_Bay)
    {
      auto t = BWAPI::UnitTypes::Terran_Engineering_Bay;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(125);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(65);
      Assert_destroyScore(195);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(48);
      Assert_dimensionDown(28);
      Assert_width(97);
      Assert_height(61);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Armory)
    {
      auto t = BWAPI::UnitTypes::Terran_Armory;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(50);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(22);
      Assert_width(96);
      Assert_height(55);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Missile_Turret)
    {
      auto t = BWAPI::UnitTypes::Terran_Missile_Turret;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(200);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(75);
      Assert_gasPrice(0);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(32);
      Assert_dimensionRight(16);
      Assert_dimensionDown(16);
      Assert_width(33);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Longbolt_Missile);
      Assert_maxAirHits(1);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(40);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestTerran_Bunker)
    {
      auto t = BWAPI::UnitTypes::Terran_Bunker;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(350);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(4);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(24);
      Assert_dimensionRight(32);
      Assert_dimensionDown(16);
      Assert_width(65);
      Assert_height(41);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Crashed_Norad_II)
    {
      auto t = BWAPI::UnitTypes::Special_Crashed_Norad_II;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(700);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(800);
      Assert_gasPrice(600);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Ion_Cannon)
    {
      auto t = BWAPI::UnitTypes::Special_Ion_Cannon;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Uraj_Crystal)
    {
      auto t = BWAPI::UnitTypes::Powerup_Uraj_Crystal;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(10000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Khalis_Crystal)
    {
      auto t = BWAPI::UnitTypes::Powerup_Khalis_Crystal;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(10000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Infested_Command_Center)
    {
      auto t = BWAPI::UnitTypes::Zerg_Infested_Command_Center;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(300);
      Assert_destroyScore(900);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(58);
      Assert_dimensionUp(41);
      Assert_dimensionRight(58);
      Assert_dimensionDown(41);
      Assert_width(117);
      Assert_height(83);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(1.00000);
      Assert_acceleration(33);
      Assert_haltDistance(2763);
      Assert_turnRadius(27);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(true);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Hatchery)
    {
      auto t = BWAPI::UnitTypes::Zerg_Hatchery;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1250);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(300);
      Assert_gasPrice(0);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(2);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(300);
      Assert_destroyScore(900);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(49);
      Assert_dimensionUp(32);
      Assert_dimensionRight(49);
      Assert_dimensionDown(32);
      Assert_width(99);
      Assert_height(65);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(true);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Lair)
    {
      auto t = BWAPI::UnitTypes::Zerg_Lair;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(1500);
      Assert_supplyRequired(0);
      Assert_supplyProvided(2);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(1200);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(49);
      Assert_dimensionUp(32);
      Assert_dimensionRight(49);
      Assert_dimensionDown(32);
      Assert_width(99);
      Assert_height(65);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(true);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Hive)
    {
      auto t = BWAPI::UnitTypes::Zerg_Hive;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(150);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(2);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(1500);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(49);
      Assert_dimensionUp(32);
      Assert_dimensionRight(49);
      Assert_dimensionDown(32);
      Assert_width(99);
      Assert_height(65);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(true);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Nydus_Canal)
    {
      auto t = BWAPI::UnitTypes::Zerg_Nydus_Canal;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Hydralisk_Den)
    {
      auto t = BWAPI::UnitTypes::Zerg_Hydralisk_Den;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(50);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(40);
      Assert_dimensionDown(24);
      Assert_width(81);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Defiler_Mound)
    {
      auto t = BWAPI::UnitTypes::Zerg_Defiler_Mound;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(150);
      Assert_destroyScore(450);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(4, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(48);
      Assert_dimensionDown(4);
      Assert_width(97);
      Assert_height(37);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Greater_Spire)
    {
      auto t = BWAPI::UnitTypes::Zerg_Greater_Spire;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(150);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(1350);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(28);
      Assert_dimensionUp(32);
      Assert_dimensionRight(28);
      Assert_dimensionDown(24);
      Assert_width(57);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Queens_Nest)
    {
      auto t = BWAPI::UnitTypes::Zerg_Queens_Nest;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(850);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(175);
      Assert_destroyScore(525);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(38);
      Assert_dimensionUp(28);
      Assert_dimensionRight(32);
      Assert_dimensionDown(28);
      Assert_width(71);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Evolution_Chamber)
    {
      auto t = BWAPI::UnitTypes::Zerg_Evolution_Chamber;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(75);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(40);
      Assert_destroyScore(120);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(44);
      Assert_dimensionUp(32);
      Assert_dimensionRight(32);
      Assert_dimensionDown(20);
      Assert_width(77);
      Assert_height(53);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Ultralisk_Cavern)
    {
      auto t = BWAPI::UnitTypes::Zerg_Ultralisk_Cavern;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(200);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(275);
      Assert_destroyScore(825);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(32);
      Assert_dimensionDown(31);
      Assert_width(73);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Spire)
    {
      auto t = BWAPI::UnitTypes::Zerg_Spire;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(150);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(250);
      Assert_destroyScore(750);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(28);
      Assert_dimensionUp(32);
      Assert_dimensionRight(28);
      Assert_dimensionDown(24);
      Assert_width(57);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Spawning_Pool)
    {
      auto t = BWAPI::UnitTypes::Zerg_Spawning_Pool;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(36);
      Assert_dimensionUp(28);
      Assert_dimensionRight(40);
      Assert_dimensionDown(18);
      Assert_width(77);
      Assert_height(47);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Creep_Colony)
    {
      auto t = BWAPI::UnitTypes::Zerg_Creep_Colony;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(75);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(40);
      Assert_destroyScore(120);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(23);
      Assert_dimensionDown(23);
      Assert_width(48);
      Assert_height(48);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Spore_Colony)
    {
      auto t = BWAPI::UnitTypes::Zerg_Spore_Colony;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(400);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(25);
      Assert_destroyScore(195);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(23);
      Assert_dimensionDown(23);
      Assert_width(48);
      Assert_height(48);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Seeker_Spores);
      Assert_maxAirHits(1);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Sunken_Colony)
    {
      auto t = BWAPI::UnitTypes::Zerg_Sunken_Colony;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(300);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(2);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(300);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(40);
      Assert_destroyScore(240);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(23);
      Assert_dimensionDown(23);
      Assert_width(48);
      Assert_height(48);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(Subterranean_Tentacle);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Overmind_With_Shell)
    {
      auto t = BWAPI::UnitTypes::Special_Overmind_With_Shell;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(5000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10000);
      Assert_size(Large);
      Assert_tileWidth(5);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(5, 3));
      Assert_dimensionLeft(80);
      Assert_dimensionUp(32);
      Assert_dimensionRight(79);
      Assert_dimensionDown(40);
      Assert_width(160);
      Assert_height(73);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Overmind)
    {
      auto t = BWAPI::UnitTypes::Special_Overmind;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10000);
      Assert_size(Large);
      Assert_tileWidth(5);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(5, 3));
      Assert_dimensionLeft(80);
      Assert_dimensionUp(32);
      Assert_dimensionRight(79);
      Assert_dimensionDown(40);
      Assert_width(160);
      Assert_height(73);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestZerg_Extractor)
    {
      auto t = BWAPI::UnitTypes::Zerg_Extractor;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(25);
      Assert_destroyScore(75);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(4, 2));
      Assert_dimensionLeft(64);
      Assert_dimensionUp(32);
      Assert_dimensionRight(63);
      Assert_dimensionDown(31);
      Assert_width(128);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(true);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Mature_Chrysalis)
    {
      auto t = BWAPI::UnitTypes::Special_Mature_Chrysalis;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(250);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Cerebrate)
    {
      auto t = BWAPI::UnitTypes::Special_Cerebrate;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2500);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(32);
      Assert_dimensionDown(31);
      Assert_width(73);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Cerebrate_Daggoth)
    {
      auto t = BWAPI::UnitTypes::Special_Cerebrate_Daggoth;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2500);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(32);
      Assert_dimensionDown(31);
      Assert_width(73);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Nexus)
    {
      auto t = BWAPI::UnitTypes::Protoss_Nexus;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(750);
      Assert_maxShields(750);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(400);
      Assert_gasPrice(0);
      Assert_buildTime(1800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(18);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(400);
      Assert_destroyScore(1200);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(56);
      Assert_dimensionUp(39);
      Assert_dimensionRight(56);
      Assert_dimensionDown(39);
      Assert_width(113);
      Assert_height(79);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Robotics_Facility)
    {
      auto t = BWAPI::UnitTypes::Protoss_Robotics_Facility;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(200);
      Assert_buildTime(1200);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(300);
      Assert_destroyScore(900);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(36);
      Assert_dimensionUp(16);
      Assert_dimensionRight(40);
      Assert_dimensionDown(20);
      Assert_width(77);
      Assert_height(37);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Pylon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Pylon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(300);
      Assert_maxShields(300);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(16);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(12);
      Assert_dimensionRight(16);
      Assert_dimensionDown(20);
      Assert_width(33);
      Assert_height(33);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Assimilator)
    {
      auto t = BWAPI::UnitTypes::Protoss_Assimilator;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(450);
      Assert_maxShields(450);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(4, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(48);
      Assert_dimensionDown(24);
      Assert_width(97);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(true);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Observatory)
    {
      auto t = BWAPI::UnitTypes::Protoss_Observatory;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(250);
      Assert_maxShields(250);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(50);
      Assert_gasPrice(100);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(175);
      Assert_destroyScore(525);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(44);
      Assert_dimensionUp(16);
      Assert_dimensionRight(44);
      Assert_dimensionDown(28);
      Assert_width(89);
      Assert_height(45);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Gateway)
    {
      auto t = BWAPI::UnitTypes::Protoss_Gateway;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(75);
      Assert_destroyScore(225);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(48);
      Assert_dimensionDown(40);
      Assert_width(97);
      Assert_height(73);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Photon_Cannon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Photon_Cannon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100);
      Assert_maxShields(100);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(750);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(20);
      Assert_dimensionUp(16);
      Assert_dimensionRight(20);
      Assert_dimensionDown(16);
      Assert_width(41);
      Assert_height(33);
      Assert_seekRange(0);
      Assert_sightRange(352);
      Assert_groundWeapon(STS_Photon_Cannon);
      Assert_maxGroundHits(1);
      Assert_airWeapon(STA_Photon_Cannon);
      Assert_maxAirHits(1);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Citadel_of_Adun)
    {
      auto t = BWAPI::UnitTypes::Protoss_Citadel_of_Adun;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(450);
      Assert_maxShields(450);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(200);
      Assert_destroyScore(600);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(24);
      Assert_dimensionUp(24);
      Assert_dimensionRight(40);
      Assert_dimensionDown(24);
      Assert_width(65);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Cybernetics_Core)
    {
      auto t = BWAPI::UnitTypes::Protoss_Cybernetics_Core;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(0);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(24);
      Assert_dimensionRight(40);
      Assert_dimensionDown(24);
      Assert_width(81);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Templar_Archives)
    {
      auto t = BWAPI::UnitTypes::Protoss_Templar_Archives;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(200);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(250);
      Assert_destroyScore(750);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(24);
      Assert_dimensionRight(32);
      Assert_dimensionDown(24);
      Assert_width(65);
      Assert_height(49);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Forge)
    {
      auto t = BWAPI::UnitTypes::Protoss_Forge;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(550);
      Assert_maxShields(550);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(600);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(100);
      Assert_destroyScore(300);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(36);
      Assert_dimensionUp(24);
      Assert_dimensionRight(36);
      Assert_dimensionDown(20);
      Assert_width(73);
      Assert_height(45);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Stargate)
    {
      auto t = BWAPI::UnitTypes::Protoss_Stargate;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(600);
      Assert_maxShields(600);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(150);
      Assert_buildTime(1050);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(300);
      Assert_destroyScore(900);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(40);
      Assert_dimensionRight(48);
      Assert_dimensionDown(32);
      Assert_width(97);
      Assert_height(73);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(true);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Stasis_Cell_Prison)
    {
      auto t = BWAPI::UnitTypes::Special_Stasis_Cell_Prison;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(64);
      Assert_dimensionUp(48);
      Assert_dimensionRight(63);
      Assert_dimensionDown(47);
      Assert_width(128);
      Assert_height(96);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Fleet_Beacon)
    {
      auto t = BWAPI::UnitTypes::Protoss_Fleet_Beacon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(300);
      Assert_gasPrice(200);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(350);
      Assert_destroyScore(1050);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(40);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(24);
      Assert_width(88);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Arbiter_Tribunal)
    {
      auto t = BWAPI::UnitTypes::Protoss_Arbiter_Tribunal;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(500);
      Assert_maxShields(500);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(150);
      Assert_buildTime(900);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(450);
      Assert_destroyScore(1350);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(44);
      Assert_dimensionUp(28);
      Assert_dimensionRight(44);
      Assert_dimensionDown(28);
      Assert_width(89);
      Assert_height(57);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Robotics_Support_Bay)
    {
      auto t = BWAPI::UnitTypes::Protoss_Robotics_Support_Bay;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(450);
      Assert_maxShields(450);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(150);
      Assert_gasPrice(100);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(125);
      Assert_destroyScore(375);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(32);
      Assert_dimensionDown(20);
      Assert_width(65);
      Assert_height(53);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestProtoss_Shield_Battery)
    {
      auto t = BWAPI::UnitTypes::Protoss_Shield_Battery;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(200);
      Assert_maxShields(200);
      Assert_maxEnergy(200);
      Assert_armor(1);
      Assert_mineralPrice(100);
      Assert_gasPrice(0);
      Assert_buildTime(450);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(50);
      Assert_destroyScore(150);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(16);
      Assert_dimensionRight(32);
      Assert_dimensionDown(16);
      Assert_width(65);
      Assert_height(33);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(true);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(true);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Khaydarin_Crystal_Form)
    {
      auto t = BWAPI::UnitTypes::Special_Khaydarin_Crystal_Form;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(250);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2500);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(64);
      Assert_dimensionUp(48);
      Assert_dimensionRight(63);
      Assert_dimensionDown(47);
      Assert_width(128);
      Assert_height(96);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Protoss_Temple)
    {
      auto t = BWAPI::UnitTypes::Special_Protoss_Temple;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(1500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(250);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(7);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(7, 3));
      Assert_dimensionLeft(112);
      Assert_dimensionUp(48);
      Assert_dimensionRight(111);
      Assert_dimensionDown(47);
      Assert_width(224);
      Assert_height(96);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_XelNaga_Temple)
    {
      auto t = BWAPI::UnitTypes::Special_XelNaga_Temple;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(5000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1500);
      Assert_gasPrice(500);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(5000);
      Assert_size(Large);
      Assert_tileWidth(5);
      Assert_tileHeight(4);
      Assert_tileSize(BWAPI::TilePosition(5, 4));
      Assert_dimensionLeft(80);
      Assert_dimensionUp(34);
      Assert_dimensionRight(79);
      Assert_dimensionDown(63);
      Assert_width(160);
      Assert_height(98);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestResource_Mineral_Field)
    {
      auto t = BWAPI::UnitTypes::Resource_Mineral_Field;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(10);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(16);
      Assert_dimensionRight(31);
      Assert_dimensionDown(15);
      Assert_width(64);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(true);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestResource_Mineral_Field_Type_2)
    {
      auto t = BWAPI::UnitTypes::Resource_Mineral_Field_Type_2;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(10);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(16);
      Assert_dimensionRight(31);
      Assert_dimensionDown(15);
      Assert_width(64);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(true);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestResource_Mineral_Field_Type_3)
    {
      auto t = BWAPI::UnitTypes::Resource_Mineral_Field_Type_3;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(10);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(2);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(2, 1));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(16);
      Assert_dimensionRight(31);
      Assert_dimensionDown(15);
      Assert_width(64);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(true);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Independant_Starport)
    {
      auto t = BWAPI::UnitTypes::Special_Independant_Starport;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(10);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(Independant_Laser_Battery);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestResource_Vespene_Geyser)
    {
      auto t = BWAPI::UnitTypes::Resource_Vespene_Geyser;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(10);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(4);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(4, 2));
      Assert_dimensionLeft(64);
      Assert_dimensionUp(32);
      Assert_dimensionRight(63);
      Assert_dimensionDown(31);
      Assert_width(128);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(288);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(true);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Warp_Gate)
    {
      auto t = BWAPI::UnitTypes::Special_Warp_Gate;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(700);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(600);
      Assert_gasPrice(200);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(2000);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Psi_Disrupter)
    {
      auto t = BWAPI::UnitTypes::Special_Psi_Disrupter;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1000);
      Assert_gasPrice(400);
      Assert_buildTime(4800);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(3600);
      Assert_size(Large);
      Assert_tileWidth(5);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(5, 3));
      Assert_dimensionLeft(80);
      Assert_dimensionUp(38);
      Assert_dimensionRight(69);
      Assert_dimensionDown(47);
      Assert_width(150);
      Assert_height(86);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Zerg_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Zerg_Beacon;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(250);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(true);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Terran_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Terran_Beacon;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(true);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Protoss_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Protoss_Beacon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(true);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Zerg_Flag_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Zerg_Flag_Beacon;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(250);
      Assert_gasPrice(0);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(true);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Terran_Flag_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Terran_Flag_Beacon;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(50);
      Assert_gasPrice(50);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(true);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Protoss_Flag_Beacon)
    {
      auto t = BWAPI::UnitTypes::Special_Protoss_Flag_Beacon;

      Assert_getRace(Protoss);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(100);
      Assert_gasPrice(100);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(true);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Power_Generator)
    {
      auto t = BWAPI::UnitTypes::Special_Power_Generator;

      Assert_getRace(Terran);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(200);
      Assert_gasPrice(50);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(600);
      Assert_size(Large);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(56);
      Assert_dimensionUp(28);
      Assert_dimensionRight(63);
      Assert_dimensionDown(43);
      Assert_width(120);
      Assert_height(72);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Overmind_Cocoon)
    {
      auto t = BWAPI::UnitTypes::Special_Overmind_Cocoon;

      Assert_getRace(Zerg);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(2500);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(1);
      Assert_mineralPrice(1000);
      Assert_gasPrice(500);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(4000);
      Assert_size(Large);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(47);
      Assert_dimensionDown(31);
      Assert_width(96);
      Assert_height(64);
      Assert_seekRange(0);
      Assert_sightRange(320);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(true);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(true);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(true);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpell_Dark_Swarm)
    {
      auto t = BWAPI::UnitTypes::Spell_Dark_Swarm;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(250);
      Assert_gasPrice(200);
      Assert_buildTime(2400);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(5);
      Assert_tileHeight(5);
      Assert_tileSize(BWAPI::TilePosition(5, 5));
      Assert_dimensionLeft(80);
      Assert_dimensionUp(80);
      Assert_dimensionRight(79);
      Assert_dimensionDown(79);
      Assert_width(160);
      Assert_height(160);
      Assert_seekRange(0);
      Assert_sightRange(256);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(true);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(true);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Floor_Missile_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Floor_Missile_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(160);
      Assert_sightRange(192);
      Assert_groundWeapon(Hellfire_Missile_Pack_Floor_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(20);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Floor_Hatch)
    {
      auto t = BWAPI::UnitTypes::Special_Floor_Hatch;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(8);
      Assert_tileHeight(4);
      Assert_tileSize(BWAPI::TilePosition(8, 4));
      Assert_dimensionLeft(128);
      Assert_dimensionUp(64);
      Assert_dimensionRight(127);
      Assert_dimensionDown(63);
      Assert_width(256);
      Assert_height(128);
      Assert_seekRange(0);
      Assert_sightRange(224);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Upper_Level_Door)
    {
      auto t = BWAPI::UnitTypes::Special_Upper_Level_Door;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(25);
      Assert_dimensionUp(17);
      Assert_dimensionRight(44);
      Assert_dimensionDown(20);
      Assert_width(70);
      Assert_height(38);
      Assert_seekRange(0);
      Assert_sightRange(32);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Right_Upper_Level_Door)
    {
      auto t = BWAPI::UnitTypes::Special_Right_Upper_Level_Door;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(44);
      Assert_dimensionUp(17);
      Assert_dimensionRight(25);
      Assert_dimensionDown(20);
      Assert_width(70);
      Assert_height(38);
      Assert_seekRange(0);
      Assert_sightRange(32);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Pit_Door)
    {
      auto t = BWAPI::UnitTypes::Special_Pit_Door;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(41);
      Assert_dimensionUp(17);
      Assert_dimensionRight(28);
      Assert_dimensionDown(20);
      Assert_width(70);
      Assert_height(38);
      Assert_seekRange(0);
      Assert_sightRange(32);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Right_Pit_Door)
    {
      auto t = BWAPI::UnitTypes::Special_Right_Pit_Door;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(10);
      Assert_size(Independent);
      Assert_tileWidth(3);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(3, 2));
      Assert_dimensionLeft(28);
      Assert_dimensionUp(17);
      Assert_dimensionRight(41);
      Assert_dimensionDown(20);
      Assert_width(70);
      Assert_height(38);
      Assert_seekRange(0);
      Assert_sightRange(32);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Floor_Gun_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Floor_Gun_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(2);
      Assert_tileHeight(2);
      Assert_tileSize(BWAPI::TilePosition(2, 2));
      Assert_dimensionLeft(32);
      Assert_dimensionUp(32);
      Assert_dimensionRight(31);
      Assert_dimensionDown(31);
      Assert_width(64);
      Assert_height(64);
      Assert_seekRange(160);
      Assert_sightRange(192);
      Assert_groundWeapon(Twin_Autocannons_Floor_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(127);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Wall_Missile_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Wall_Missile_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(160);
      Assert_sightRange(192);
      Assert_groundWeapon(Hellfire_Missile_Pack_Wall_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Wall_Flame_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Wall_Flame_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(64);
      Assert_sightRange(96);
      Assert_groundWeapon(Flame_Thrower_Wall_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Right_Wall_Missile_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Right_Wall_Missile_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(160);
      Assert_sightRange(192);
      Assert_groundWeapon(Hellfire_Missile_Pack_Wall_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Right_Wall_Flame_Trap)
    {
      auto t = BWAPI::UnitTypes::Special_Right_Wall_Flame_Trap;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(50);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(100);
      Assert_size(Large);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(64);
      Assert_sightRange(96);
      Assert_groundWeapon(Flame_Thrower_Wall_Trap);
      Assert_maxGroundHits(1);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(true);
      Assert_isRobotic(false);
      Assert_isDetector(true);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestSpecial_Start_Location)
    {
      auto t = BWAPI::UnitTypes::Special_Start_Location;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(4);
      Assert_tileHeight(3);
      Assert_tileSize(BWAPI::TilePosition(4, 3));
      Assert_dimensionLeft(48);
      Assert_dimensionUp(32);
      Assert_dimensionRight(48);
      Assert_dimensionDown(32);
      Assert_width(97);
      Assert_height(65);
      Assert_seekRange(0);
      Assert_sightRange(32);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(true);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(true);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(true);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Flag)
    {
      auto t = BWAPI::UnitTypes::Powerup_Flag;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(100000);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Young_Chrysalis)
    {
      auto t = BWAPI::UnitTypes::Powerup_Young_Chrysalis;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Psi_Emitter)
    {
      auto t = BWAPI::UnitTypes::Powerup_Psi_Emitter;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Data_Disk)
    {
      auto t = BWAPI::UnitTypes::Powerup_Data_Disk;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Khaydarin_Crystal)
    {
      auto t = BWAPI::UnitTypes::Powerup_Khaydarin_Crystal;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(true);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Mineral_Cluster_Type_1)
    {
      auto t = BWAPI::UnitTypes::Powerup_Mineral_Cluster_Type_1;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Mineral_Cluster_Type_2)
    {
      auto t = BWAPI::UnitTypes::Powerup_Mineral_Cluster_Type_2;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Protoss_Gas_Orb_Type_1)
    {
      auto t = BWAPI::UnitTypes::Powerup_Protoss_Gas_Orb_Type_1;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Protoss_Gas_Orb_Type_2)
    {
      auto t = BWAPI::UnitTypes::Powerup_Protoss_Gas_Orb_Type_2;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Zerg_Gas_Sac_Type_1)
    {
      auto t = BWAPI::UnitTypes::Powerup_Zerg_Gas_Sac_Type_1;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Zerg_Gas_Sac_Type_2)
    {
      auto t = BWAPI::UnitTypes::Powerup_Zerg_Gas_Sac_Type_2;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Terran_Gas_Tank_Type_1)
    {
      auto t = BWAPI::UnitTypes::Powerup_Terran_Gas_Tank_Type_1;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestPowerup_Terran_Gas_Tank_Type_2)
    {
      auto t = BWAPI::UnitTypes::Powerup_Terran_Gas_Tank_Type_2;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Upgrade_60);
      Assert_maxHitPoints(800);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(1);
      Assert_gasPrice(1);
      Assert_buildTime(1);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(255);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Independent);
      Assert_tileWidth(1);
      Assert_tileHeight(1);
      Assert_tileSize(BWAPI::TilePosition(1, 1));
      Assert_dimensionLeft(16);
      Assert_dimensionUp(16);
      Assert_dimensionRight(15);
      Assert_dimensionDown(15);
      Assert_width(32);
      Assert_height(32);
      Assert_seekRange(0);
      Assert_sightRange(160);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(true);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestNone)
    {
      auto t = BWAPI::UnitTypes::None;

      Assert_getRace(None);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(None);
      Assert_maxHitPoints(0);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(0);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(None);
      Assert_tileWidth(0);
      Assert_tileHeight(0);
      Assert_tileSize(BWAPI::TilePosition(0, 0));
      Assert_dimensionLeft(0);
      Assert_dimensionUp(0);
      Assert_dimensionRight(0);
      Assert_dimensionDown(0);
      Assert_width(1);
      Assert_height(1);
      Assert_seekRange(0);
      Assert_sightRange(0);
      Assert_groundWeapon(None);
      Assert_maxGroundHits(0);
      Assert_airWeapon(None);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(false);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }
    TEST_METHOD(TestUnknown)
    {
      auto t = BWAPI::UnitTypes::Unknown;

      Assert_getRace(Unknown);
      Assert_requiredTech(None);
      Assert_cloakingTech(None);
      Assert_armorUpgrade(Unknown);
      Assert_maxHitPoints(0);
      Assert_maxShields(0);
      Assert_maxEnergy(0);
      Assert_armor(0);
      Assert_mineralPrice(0);
      Assert_gasPrice(0);
      Assert_buildTime(0);
      Assert_supplyRequired(0);
      Assert_supplyProvided(0);
      Assert_spaceRequired(0);
      Assert_spaceProvided(0);
      Assert_buildScore(0);
      Assert_destroyScore(0);
      Assert_size(Unknown);
      Assert_tileWidth(0);
      Assert_tileHeight(0);
      Assert_tileSize(BWAPI::TilePosition(0, 0));
      Assert_dimensionLeft(0);
      Assert_dimensionUp(0);
      Assert_dimensionRight(0);
      Assert_dimensionDown(0);
      Assert_width(1);
      Assert_height(1);
      Assert_seekRange(0);
      Assert_sightRange(0);
      Assert_groundWeapon(Unknown);
      Assert_maxGroundHits(0);
      Assert_airWeapon(Unknown);
      Assert_maxAirHits(0);
      Assert_topSpeed(0.000000);
      Assert_acceleration(0);
      Assert_haltDistance(0);
      Assert_turnRadius(0);
      Assert_canProduce(false);
      Assert_canAttack(true);
      Assert_canMove(false);
      Assert_isFlyer(false);
      Assert_regeneratesHP(false);
      Assert_isSpellcaster(false);
      Assert_hasPermanentCloak(false);
      Assert_isInvincible(false);
      Assert_isOrganic(false);
      Assert_isMechanical(false);
      Assert_isRobotic(false);
      Assert_isDetector(false);
      Assert_isResourceContainer(false);
      Assert_isResourceDepot(false);
      Assert_isRefinery(false);
      Assert_isWorker(false);
      Assert_requiresPsi(false);
      Assert_requiresCreep(false);
      Assert_isTwoUnitsInOneEgg(false);
      Assert_isBurrowable(false);
      Assert_isCloakable(false);
      Assert_isBuilding(false);
      Assert_isAddon(false);
      Assert_isFlyingBuilding(false);
      Assert_isNeutral(false);
      Assert_isHero(false);
      Assert_isPowerup(false);
      Assert_isBeacon(false);
      Assert_isFlagBeacon(false);
      Assert_isSpecialBuilding(false);
      Assert_isSpell(false);
      Assert_producesLarva(false);
      Assert_isMineralField(false);
      Assert_isCritter(false);
      Assert_canBuildAddon(false);
    }

  };
}